# Vault Cluster Configuration

[[_TOC_]]

The `vaulttool` configuration is a *yaml* format.

The vault management configuration describes all of the needed settings for initializing, joining, and leaving vault clusters.

|Name|Description|
|---|---|
|`extra-hostnames`|List of extra hostnames to be added to the certificate request. This might be the hostname associated with a load-balancer, for example.|
|`hostname-prefix`|Prefix used when constructing a hostname for a new vault node|
|`domain`|DNS domain name new vault nodes should appear in|
|`cert`|Certificate configuration for generating a certificate for a vault node. See [Certificate Configuration](#certificate-configuration).|
|`dns`|DNS configuration used to fulfill ACME challenges. See [DNS Configuration](#dns-configuration).
|`lb`|*Optional.* Load balancer configuration used to balance traffic between vault nodes. If not specified, no load balancer will be used. See [Load Balancer Configuration](#load-balancer-configuration).
|`vault`|Vault cluster configuration. See [Vault Configuration](#vault-configuration).
|`vm`|VM configuration used to add and remove nodes. See [VM Configuration](#vm-configuration).

### Vault Configuration

|Name|Description|
|---|---|
|`join-address`|Address used to join nodes to an existing cluster.|
|`secret-threshold`|Number of keys required to unseal/recover a vault node.|
|`pgp-keys`|List of PGP keys used to encrypt unseal/recovery keys. See `root-token-pgp-key` for format of list entries.|
|`root-token-pgp-key`|PGP key used to encrypt initial root token. An object containing either a `data` or `filename` containing key data or a filename for loading the data respectively. The `data` field takes priority over `filename`. PGP key should be an ascii armored public key in the format generated by `gpg -a --export <key_id>`.
|`seal`|*Optional.* Seal configuration for automatically unsealing a node. If specified, the seal will be used to unseal, and the generated keys will be recovery keys. See [Seal Configuration](#seal-configuration).

### Seal Configuration

|Name|Description|
|---|---|
|`address`|Address of a vault instance used to unseal this cluster.|
|`key-name`|The transit key to use for encryption and decryption.|
|`mount-path`|The mount path to the transit secret engine.|
|`role-name`|The name of the role used to generate the token a vault node will use to connect to the vault used to unseal this cluster. This should be a role defined on the unseal vault instance.|
|`transport`|*Optional.* A transport configuration for configuring TLS when connecting to the vault used to unseal this cluster. See [Transport](#transport) for details.|

## Certificate Configuration

Certificate providers allow the tool to request certificates from a certificate authority.

Only the *ACME* certificate provider is supported.

### ACME

The ACME provider requests certificates from an ACME compliant certificate authority such as [Let's Encrypt](https://letsencrypt.org/). This provider currently only supports the `dns-01` challenge.

|Name|Default|Description|
|---|---|---|
|`contact`||List of strings containing contact information. See [RFC 8555 Section 7.1.2](https://tools.ietf.org/html/rfc8555#section-7.1.2) for details.
|`dns`||DNS configuration used to fulfill ACME challenges. See [DNS Configuration](#dns-configuration)
|`private-key-file`||Filename to load the ACME account private key from. This private key must be registered before it is used. Registration can be done with the included `vaulttool cert register` command.|
|`endpoint`|https://acme-v02.api.letsencrypt.org/directory|*Optional.* Set the ACME API endpoint to use when requesting certificates.
|`transport`||*Optional.* A transport configuration for configuring TLS when connecting to the ACME API. See [Transport](#transport) for details.|

```yaml
cert:
  contact:
  - mailto:user@example.com
  dns:
    type: DigitalOcean
  private-key-file: acme-key.pem
```

## DNS Configuration

DNS providers allow the tool to add and remove DNS entries.

Two types of DNS configurations are available:

* DigitalOcean
* HostsFile

### Digital Ocean

The DigitalOcean provider creates and removes DNS entries from the [Digital Ocean](https://digitalocean.com) dns manager. This provider will detect the correct domain from the API based on the best match for the hostname or the record being added or removed. The domain must already exist.

*Note:* Either the `DIGITALOCEAN_ACCESS_TOKEN` environment variable must be set, or a doctl must be authenticated with a valid Digital Ocean API access token to use this provider.

|Name|Default|Description|
|---|---|---|
|`endpoint`|https://api.digitalocean.com/|*Optional.* Set the Digital Ocean API endpoint to use when manipulating DNS entries.|
|`transport`||*Optional.* A transport configuration for configuring TLS when connecting to the DigitalOcean API. See [Transport](#transport) for details.|

```yaml
dns:
  type: DigitalOcean
```

### Hosts File

The Hosts provider creates and removes entries in `/etc/hosts` on the local host. This provider only supports *A* records, and **is not suitable for production use.**

This provider does not provide any customizable configuration.

```yaml
dns:
  type: HostsFile
```

## Load Balancer Configuration

Load Balancer providers allow the tool to add and remove backend nodes from a Load Balancer.

Only the *DNS* provider is supported.

### DNS

The DNS provider leverages a DNS configuration to add and remove records from a DNS load balancer. While this isn't a traditional load balancer, it does allows clients to resolve any one of the added nodes.

|Name|Description
|---|---|
|`hostname`|Hostname for the load balancer. An *A* record from this hostname will be created for each node.|
|`dns`|DNS configuration used to fulfill ACME challenges. See [DNS Configuration](#dns-configuration)

```
lb:
  type: DNS
  dns-lb:
    dns:
      type: DigitalOcean
    hostname: example.com
```

## VM Configuration

The VM configuration allows the tool to add and remove VMs from a VM host.

Two types of VM configurations are available:

* DigitalOcean
* LocalVault

### DigitalOcean

The DigitalOcean provider creates and removes VMs using the [Digital Ocean](https://digitalocean.com) API.

*Note:* Either the `DIGITALOCEAN_ACCESS_TOKEN` environment variable must be set, or a doctl must be authenticated with a valid Digital Ocean API access token to use this provider.

|Name|Default|Description|
|---|---|---|
|`region`||Region name where VM is created. E.g. "nyc3"
|`size`||Size of VM to be created. E.g. "s-1vcpu-1gb"
|`image`||Name of image used to provision VM. This image must exist. This should likely be built from https://gitlab.com/slagit/vault/image, but any compatible image may be used.
|`ssh-keys`||List of SSH keys provisioned on the VM. This is a list of objects with either a `fingerprint` or `id` attribute. This is required by the Digital Ocean API even if the image doesn't support SSH access.
|`vpc`||Name of VPC that VM will be connected to. E.g. "default-nyc3"
|`endpoint`|https://api.digitalocean.com/|*Optional.* Set the Digital Ocean API endpoint to use when manipulating DNS entries.|
|`tags`||*Optional.* A list of tags to be added to the created VM
|`transport`||*Optional.* A transport configuration for configuring TLS when connecting to the DigitalOcean API. See [Transport](#transport) for details.|

```yaml
vm:
  type: DigitalOcean
  digital-ocean:
    region: nyc3
    size: s-1vcpu-1gb
    image: vault-1.0.0
    ssh-keys:
    - fingerprint: 00:11:22:33:44:55:66:77:88:99:aa:bb:cc:dd:ee:ff
    vpc: default-nyc3
```

### LocalVault

The LocalVault provider runs a copy of vault on the local host, bound to a loopback (127.0.0.0/8) address. This does not create VMs, but does function as a light-weight tool for testing during development. The vault binary must be installed on the host system. **This provider is not suitable for production use.**

|Name|Default|Description|
|---|---|---|
|`instance-path`|/tmp/vault|Path to local state where vault data will be managed. A separate directory under this path will be created for each vault instance.|
|`vault-executable`|/usr/sbin/vault|Path to the vault binary executable.|

```yaml
vm:
  type: LocalVault
```

## Common Configuration

### Transport

The transport configuration is a common format for setting TLS parameters for other providers.

|Name|Description|
|---|---|
|`ca-certificate`|*Optional.* Load additional CA certificates from the given file. This option is ignored if `ca-certificate-data` is set.|
|`ca-certificate-data`|*Optional.* Include the PEM format certificate in the CA certificates used to verify a connection. The system configured CA certificates will automatically be included. This option takes precedence over `ca-certificate`.|
